diff -r e16bdc0054ce src/company_base.h
--- a/src/company_base.h
+++ b/src/company_base.h
@@ -17,6 +17,7 @@
 #include "autoreplace_type.h"
 #include "tile_type.h"
 #include "settings_type.h"
+#include "cargo_type.h"
 #include "group.h"
 
 /** Statistics about the economy. */
@@ -26,6 +27,7 @@
 	CargoArray delivered_cargo; ///< The amount of delivered cargo.
 	int32 performance_history;  ///< Company score (scale 0-1000)
 	Money company_value;        ///< The value of the company.
+	Money cargo_income[NUM_CARGO]; ///< Cargo income from each cargo type	
 };
 
 struct CompanyInfrastructure {
@@ -124,6 +126,12 @@
 
 	CompanyInfrastructure infrastructure; ///< NOSAVE: Counts of company owned infrastructure.
 
+	uint32 cargo_units[NUM_CARGO];   ///< Total amount of transported cargo for each cargo ID
+	Money cargo_income[NUM_CARGO];   ///< Total income from transported cargo for each cargo ID
+
+	uint32 cargo_units_period[2][NUM_CARGO];   ///< Monthly amount of transported cargo for each cargo ID 
+	Money cargo_income_period[2][NUM_CARGO];   ///< Monthly income from transported cargo for each cargo ID
+
 	/**
 	 * Is this company a valid company, controlled by the computer (a NoAI program)?
 	 * @param index Index in the pool.
diff -r e16bdc0054ce src/company_cmd.cpp
--- a/src/company_cmd.cpp
+++ b/src/company_cmd.cpp
@@ -38,6 +38,7 @@
 #include "story_base.h"
 
 #include "table/strings.h"
+#include "cargo_type.h"
 
 #include "safeguards.h"
 
@@ -69,6 +70,8 @@
 
 	for (uint j = 0; j < 4; j++) this->share_owners[j] = COMPANY_SPECTATOR;
 	InvalidateWindowData(WC_PERFORMANCE_DETAIL, 0, INVALID_COMPANY);
+	InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+	InvalidateWindowClassesData(WC_WATCH_COMPANYA, 1);
 }
 
 /** Destructor. */
@@ -91,6 +94,8 @@
 	InvalidateWindowData(WC_LINKGRAPH_LEGEND, 0);
 	/* If the currently shown error message has this company in it, then close it. */
 	InvalidateWindowData(WC_ERRMSG, 0);
+	InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+	InvalidateWindowClassesData(WC_WATCH_COMPANYA, 1);
 }
 
 /**
@@ -576,9 +581,23 @@
 	AI::BroadcastNewEvent(new ScriptEventCompanyNew(c->index), c->index);
 	Game::NewEvent(new ScriptEventCompanyNew(c->index));
 
+	if (!is_ai) UpdateAllTownVirtCoords(); //coloured rating
+
+	for (uint j = 0; j < NUM_CARGO; j++) {
+		c->cargo_income[j] = 0;
+		c->cargo_units[j] = 0;
+	}
+	CargoResetPeriods(c);
+
 	return c;
 }
 
+void CargoResetPeriods(Company *c){
+	memmove(&c->cargo_income_period[1], &c->cargo_income_period[0], sizeof(c->cargo_income_period[0]));
+	memset(&c->cargo_income_period, 0, sizeof(c->cargo_income_period[0]));
+	memmove(&c->cargo_units_period[1], &c->cargo_units_period[0], sizeof(c->cargo_units_period[0]));
+	memset(&c->cargo_units_period, 0, sizeof(c->cargo_units_period[0]));
+}
 /** Start the next competitor now. */
 void StartupCompanies()
 {
@@ -1081,6 +1100,7 @@
 		free(c->name);
 		c->name = reset ? NULL : stredup(text);
 		MarkWholeScreenDirty();
+		InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
 		CompanyAdminUpdate(c);
 	}
 
diff -r e16bdc0054ce src/company_func.h
--- a/src/company_func.h
+++ b/src/company_func.h
@@ -31,6 +31,7 @@
 void SubtractMoneyFromCompanyFract(CompanyID company, CommandCost cost);
 CommandCost CheckOwnership(Owner owner, TileIndex tile = 0);
 CommandCost CheckTileOwnership(TileIndex tile);
+void CargoResetPeriods(Company *c);
 
 extern CompanyByte _local_company;
 extern CompanyByte _current_company;
diff -r e16bdc0054ce src/company_gui.cpp
--- a/src/company_gui.cpp
+++ b/src/company_gui.cpp
@@ -1919,7 +1919,14 @@
 							NWidget(WWT_TEXTBTN, COLOUR_GREY, WID_C_RELOCATE_HQ), SetFill(1, 0), SetDataTip(STR_COMPANY_VIEW_RELOCATE_HQ, STR_COMPANY_VIEW_RELOCATE_COMPANY_HEADQUARTERS),
 							NWidget(NWID_SPACER), SetMinimalSize(90, 0),
 						EndContainer(),
-						NWidget(NWID_SPACER), SetFill(0, 1),
+						NWidget(NWID_SELECTION, INVALID_COLOUR, WID_C_SELECT_MOD),
+							NWidget(NWID_SPACER), SetMinimalSize(0, 0), SetFill(0, 1),
+							NWidget(NWID_VERTICAL), SetPIP(4, 2, 4),
+								NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, WID_C_MOD_COMPANY_JOIN), SetFill(1, 0), SetDataTip(STR_MOD_COMPANY_JOIN_BUTTON, STR_NULL),
+								NWidget(WWT_TEXTBTN, COLOUR_GREY, WID_C_MOD_COMPANY_TOGGLE_LOCK), SetFill(1, 0), SetDataTip(STR_MOD_TOGGLE_LOCK_BUTTON, STR_NULL),
+								NWidget(WWT_TEXTBTN, COLOUR_GREY, WID_C_MOD_COMPANY_RESET), SetFill(1, 0), SetDataTip(STR_MOD_COMPANY_RESET_BUTTON, STR_NULL),
+							EndContainer(),
+						EndContainer(),
 					EndContainer(),
 				EndContainer(),
 				NWidget(WWT_TEXT, COLOUR_GREY, WID_C_DESC_COMPANY_VALUE), SetDataTip(STR_COMPANY_VIEW_COMPANY_VALUE, STR_NULL), SetFill(1, 0),
@@ -1989,6 +1996,16 @@
 /**
  * Window with general information about a company
  */
+static void ResetCallback(Window *w, bool confirmed)
+{
+	if (confirmed) {
+		CompanyID company2 = (CompanyID)w->window_number;
+		char msg[128];
+		seprintf(msg, lastof(msg), "!reset %i", company2 + 1);
+		NetworkClientSendChatToServer(msg);
+	}
+}
+
 struct CompanyWindow : Window
 {
 	CompanyWidgets query_widget;
@@ -2010,6 +2027,9 @@
 		/* Display planes of the #WID_C_SELECT_BUTTONS selection widget. */
 		CWP_BUTTONS_LOCAL = 0, ///< Buttons of the local company.
 		CWP_BUTTONS_OTHER,     ///< Buttons of the other companies.
+
+		CWP_BUTTONS_PLAYER = 0,
+		CWP_BUTTONS_MOD,
 	};
 
 	CompanyWindow(WindowDesc *desc, WindowNumber window_number) : Window(desc)
@@ -2079,12 +2099,26 @@
 			}
 			this->SetWidgetDisabledState(WID_C_COMPANY_JOIN,   c->is_ai);
 
+			plane = (int)(_networking && _novarole ? CWP_BUTTONS_MOD: CWP_BUTTONS_PLAYER);
+			wi = this->GetWidget<NWidgetStacked>(WID_C_SELECT_MOD);
+			if (plane != wi->shown_plane) {
+				wi->SetDisplayedPlane(plane);
+				reinit = true;
+			}
+
 			if (reinit) {
 				this->ReInit();
 				return;
 			}
 		}
 
+		// if(!_networking) {
+		// 	this->SetWidgetDisabledState(CW_WIDGET_COMPANY_RESUME, true);
+		// 	this->SetWidgetDisabledState(CW_WIDGET_COMPANY_SUSPEND, true);
+		// 	this->SetWidgetDisabledState(CW_WIDGET_COMPANY_RESET, true);
+		// 	this->SetWidgetDisabledState(CW_WIDGET_COMPANY_JOIN2, true);
+		// }
+
 		this->DrawWidgets();
 	}
 
@@ -2141,6 +2175,15 @@
 				break;
 			}
 
+			// case CW_WIDGET_COMPANY_RESUME:
+			// case CW_WIDGET_COMPANY_SUSPEND:
+			// case CW_WIDGET_COMPANY_RESET:
+			// case CW_WIDGET_COMPANY_JOIN2:
+			// 	if(!_novarole){
+			// 		size->width = 0;
+			// 		size->height = 0;
+			// 	}
+			// 	break;
 #ifdef ENABLE_NETWORK
 			case WID_C_HAS_PASSWORD:
 				*size = maxdim(*size, GetSpriteSize(SPR_LOCK));
@@ -2367,6 +2410,34 @@
 					/* just send the join command */
 					NetworkClientRequestMove(company);
 				}
+				MarkWholeScreenDirty();
+				break;
+			}
+
+			case WID_C_MOD_COMPANY_JOIN: {
+				if (!_novarole) return;
+				CompanyID company2 = (CompanyID)this->window_number;
+				// this->query_widget = WID_C_MOD_COMPANY_JOIN;
+				char msg[128];
+				seprintf(msg, lastof(msg), "!move %i", company2 + 1);
+				NetworkClientSendChatToServer(msg);
+				MarkWholeScreenDirty();
+				break;
+			}
+			case WID_C_MOD_COMPANY_RESET: {
+				if (!_networking) return;
+				this->query_widget = WID_C_MOD_COMPANY_RESET;
+				ShowQuery(STR_XI_RESET_CAPTION, STR_XI_REALY_RESET, this, ResetCallback);
+				MarkWholeScreenDirty();
+				break;
+			}
+			case WID_C_MOD_COMPANY_TOGGLE_LOCK: {
+				if (!_novarole) return;
+				CompanyID company2 = (CompanyID)this->window_number;
+				char msg[128];
+				seprintf(msg, lastof(msg), "!lockp %i", company2 + 1);
+				NetworkClientSendChatToServer(msg);
+				MarkWholeScreenDirty();
 				break;
 			}
 #endif /* ENABLE_NETWORK */
diff -r e16bdc0054ce src/crashlog.cpp
--- a/src/crashlog.cpp
+++ b/src/crashlog.cpp
@@ -87,7 +87,7 @@
 char *CrashLog::LogOpenTTDVersion(char *buffer, const char *last) const
 {
 	return buffer + seprintf(buffer, last,
-			"OpenTTD version:\n"
+			"OpenTTD version: Novapolis patched client  http://www.novapolis.net\n\n\n"
 			" Version:    %s (%d)\n"
 			" NewGRF ver: %08x\n"
 			" Bits:       %d\n"
@@ -318,7 +318,7 @@
 char *CrashLog::FillCrashLog(char *buffer, const char *last) const
 {
 	time_t cur_time = time(NULL);
-	buffer += seprintf(buffer, last, "*** OpenTTD Crash Report ***\n\n");
+	buffer += seprintf(buffer, last, "*** OpenTTD Crash Report ***\nNovapolis patched client  http://www.novapolis.net\nPlease, unless you encounter this bug with unpatched OpenTTD version, report bug to Novapolis team\n\n");
 	buffer += seprintf(buffer, last, "Crash at: %s", asctime(gmtime(&cur_time)));
 
 	YearMonthDay ymd;
diff -r e16bdc0054ce src/depot_gui.cpp
--- a/src/depot_gui.cpp
+++ b/src/depot_gui.cpp
@@ -28,7 +28,7 @@
 #include "vehiclelist.h"
 #include "order_backup.h"
 #include "zoom_func.h"
-
+#include "hotkeys.h"
 #include "widgets/depot_widget.h"
 
 #include "table/strings.h"
@@ -81,34 +81,6 @@
 	EndContainer(),
 };
 
-static WindowDesc _train_depot_desc(
-	WDP_AUTO, "depot_train", 362, 123,
-	WC_VEHICLE_DEPOT, WC_NONE,
-	0,
-	_nested_train_depot_widgets, lengthof(_nested_train_depot_widgets)
-);
-
-static WindowDesc _road_depot_desc(
-	WDP_AUTO, "depot_roadveh", 316, 97,
-	WC_VEHICLE_DEPOT, WC_NONE,
-	0,
-	_nested_train_depot_widgets, lengthof(_nested_train_depot_widgets)
-);
-
-static WindowDesc _ship_depot_desc(
-	WDP_AUTO, "depot_ship", 306, 99,
-	WC_VEHICLE_DEPOT, WC_NONE,
-	0,
-	_nested_train_depot_widgets, lengthof(_nested_train_depot_widgets)
-);
-
-static WindowDesc _aircraft_depot_desc(
-	WDP_AUTO, "depot_aircraft", 332, 99,
-	WC_VEHICLE_DEPOT, WC_NONE,
-	0,
-	_nested_train_depot_widgets, lengthof(_nested_train_depot_widgets)
-);
-
 extern void DepotSortList(VehicleList *list);
 
 /**
@@ -297,9 +269,16 @@
 						this->sel, EIT_IN_DEPOT, free_wagon ? 0 : this->hscroll->GetPosition(), this->vehicle_over);
 
 				/* Length of consist in tiles with 1 fractional digit (rounded up) */
-				SetDParam(0, CeilDiv(u->gcache.cached_total_length * 10, TILE_SIZE));
-				SetDParam(1, 1);
-				DrawString(rtl ? left + WD_FRAMERECT_LEFT : right - this->count_width, rtl ? left + this->count_width : right - WD_FRAMERECT_RIGHT, y + (this->resize.step_height - FONT_HEIGHT_SMALL) / 2, STR_TINY_BLACK_DECIMAL, TC_FROMSTRING, SA_RIGHT); // Draw the counter
+				if (_settings_client.gui.old_depot_train_length_calc) {
+					SetDParam(0, CeilDiv(u->gcache.cached_total_length, 8));
+					SetDParam(1, 1);
+					DrawString(rtl ? left + WD_FRAMERECT_LEFT : right - this->count_width, rtl ? left + this->count_width : right - WD_FRAMERECT_RIGHT, y + (this->resize.step_height - FONT_HEIGHT_SMALL) / 2, STR_TINY_BLACK_COMA, TC_FROMSTRING, SA_RIGHT); // Draw the counter
+				}
+				else {
+					SetDParam(0, CeilDiv(u->gcache.cached_total_length * 10, TILE_SIZE));
+					SetDParam(1, 1);
+					DrawString(rtl ? left + WD_FRAMERECT_LEFT : right - this->count_width, rtl ? left + this->count_width : right - WD_FRAMERECT_RIGHT, y + (this->resize.step_height - FONT_HEIGHT_SMALL) / 2, STR_TINY_BLACK_DECIMAL, TC_FROMSTRING, SA_RIGHT); // Draw the counter
+				}
 				break;
 			}
 
@@ -1017,8 +996,24 @@
 
 		return ES_NOT_HANDLED;
 	}
+
+	virtual EventState OnHotkey(int hotkey)
+	{
+		if (this->owner != _local_company) return ES_NOT_HANDLED;
+		return Window::OnHotkey(hotkey);
+	}
+
+	static HotkeyList hotkeys;
 };
 
+static Hotkey depot_hotkeys[] = {
+	Hotkey(WKC_CTRL | 'F', "depot_go_all", WID_D_START_ALL),
+	Hotkey('R', "depot_build_vehicle", WID_D_BUILD),
+	Hotkey(WKC_NONE, "depot_clone_vehicle", WID_D_CLONE),
+	HOTKEY_LIST_END
+};
+HotkeyList DepotWindow::hotkeys("depot_gui", depot_hotkeys);
+
 static void DepotSellAllConfirmationCallback(Window *win, bool confirmed)
 {
 	if (confirmed) {
@@ -1029,6 +1024,38 @@
 	}
 }
 
+static WindowDesc _train_depot_desc(
+	WDP_AUTO, "depot_train", 362, 123,
+	WC_VEHICLE_DEPOT, WC_NONE,
+	0,
+	_nested_train_depot_widgets, lengthof(_nested_train_depot_widgets),
+	&DepotWindow::hotkeys
+);
+
+static WindowDesc _road_depot_desc(
+	WDP_AUTO, "depot_roadveh", 316, 97,
+	WC_VEHICLE_DEPOT, WC_NONE,
+	0,
+	_nested_train_depot_widgets, lengthof(_nested_train_depot_widgets),
+	&DepotWindow::hotkeys
+);
+
+static WindowDesc _ship_depot_desc(
+	WDP_AUTO, "depot_ship", 306, 99,
+	WC_VEHICLE_DEPOT, WC_NONE,
+	0,
+	_nested_train_depot_widgets, lengthof(_nested_train_depot_widgets),
+	&DepotWindow::hotkeys
+);
+
+static WindowDesc _aircraft_depot_desc(
+	WDP_AUTO, "depot_aircraft", 332, 99,
+	WC_VEHICLE_DEPOT, WC_NONE,
+	0,
+	_nested_train_depot_widgets, lengthof(_nested_train_depot_widgets),
+	&DepotWindow::hotkeys
+);
+
 /**
  * Opens a depot window
  * @param tile The tile where the depot/hangar is located
diff -r e16bdc0054ce src/economy.cpp
--- a/src/economy.cpp
+++ b/src/economy.cpp
@@ -53,6 +53,7 @@
 
 #include "table/strings.h"
 #include "table/pricebase.h"
+#include "cargo_table_gui.h"
 
 #include "safeguards.h"
 
@@ -386,6 +387,8 @@
 		/* Reset the ratings for the old owner */
 		t->ratings[old_owner] = RATING_INITIAL;
 		ClrBit(t->have_ratings, old_owner);
+		ClrBit(t->advertise_regularly, old_owner);
+		ClrBit(t->do_powerfund, old_owner);
 
 		/* Transfer exclusive rights */
 		if (t->exclusive_counter > 0 && t->exclusivity == old_owner) {
@@ -1108,6 +1111,14 @@
 	const CargoSpec *cs = CargoSpec::Get(cargo_type);
 	st->town->received[cs->town_effect].new_act += accepted;
 
+	/* Increase town's counter for all goods types only if delivered near town*/
+	if(CB_Enabled()){
+		if (_settings_client.gui.cb_distance_check == 0 || (DistanceManhattan(st->town->xy, st->xy) <= _settings_client.gui.cb_distance_check)) {
+			st->town->new_act_cargo[cargo_type] += accepted;
+			InvalidateWindowData(WC_CB_TOWN, st->town->index);
+		}
+	}
+
 	/* Determine profit */
 	Money profit = GetTransportedGoodsIncome(accepted, DistanceManhattan(source_tile, st->xy), days_in_transit, cargo_type);
 
@@ -1124,6 +1135,16 @@
 		}
 	}
 
+	company->cargo_income[cargo_type] += profit;
+	company->cargo_units[cargo_type] += num_pieces;
+
+	company->cargo_income_period[0][cargo_type] += profit;
+	company->cargo_units_period[0][cargo_type] += num_pieces;
+
+	company->cur_economy.cargo_income[cargo_type] += profit;
+
+	InvalidateCargosWindows(company->index);
+
 	return profit;
 }
 
@@ -1950,6 +1971,11 @@
 	}
 	CompaniesPayInterest();
 	HandleEconomyFluctuations();
+
+	Company *c;
+	FOR_ALL_COMPANIES(c){
+		CargoResetPeriods(c);
+	}
 }
 
 static void DoAcquireCompany(Company *c)
diff -r e16bdc0054ce src/gfx.cpp
--- a/src/gfx.cpp
+++ b/src/gfx.cpp
@@ -34,6 +34,7 @@
 byte _support8bpp;
 CursorVars _cursor;
 bool _ctrl_pressed;   ///< Is Ctrl pressed?
+bool _alt_pressed;    ///< Is Alt pressed?
 bool _shift_pressed;  ///< Is Shift pressed?
 byte _fast_forward;
 bool _left_button_down;     ///< Is left mouse button pressed?
diff -r e16bdc0054ce src/gfx_func.h
--- a/src/gfx_func.h
+++ b/src/gfx_func.h
@@ -55,6 +55,7 @@
 extern byte _support8bpp;
 extern CursorVars _cursor;
 extern bool _ctrl_pressed;   ///< Is Ctrl pressed?
+extern bool _alt_pressed;    ///< Is Alt pressed?
 extern bool _shift_pressed;  ///< Is Shift pressed?
 extern byte _fast_forward;
 
diff -r e16bdc0054ce src/gfx_type.h
--- a/src/gfx_type.h
+++ b/src/gfx_type.h
@@ -104,6 +104,16 @@
 	WKC_COMMA       = 151, ///< , Comma
 	WKC_PERIOD      = 152, ///< . Period
 	WKC_MINUS       = 153, ///< - Minus
+
+	WKC_L_BRACE     = 154, ///< { Left brace
+	WKC_R_BRACE     = 155, ///< } Right brace
+	
+	WKC_L_PAREN     = 157, ///< ( Left parentheses
+	WKC_R_PAREN     = 158, ///< ) Right parentheses
+	WKC_PLUS        = 159, ///< + Plus
+	WKC_EXCLAIM     = 160, ///< ! Exclamation mark
+	WKC_ASTERISK    = 161, ///< * Asterisk
+	WKC_DOLLAR      = 162, ///< $ Dollar sign
 };
 
 /** A single sprite of a list of animated cursors */
diff -r e16bdc0054ce src/gfxinit.cpp
--- a/src/gfxinit.cpp
+++ b/src/gfxinit.cpp
@@ -192,6 +192,7 @@
 			i++
 		);
 	}
+	LoadGrfFile("innerhighlight.grf", SPR_INNER_HIGHLIGHT_BASE, i++);
 
 	/* Initialize the unicode to sprite mapping table */
 	InitializeUnicodeGlyphMap();
diff -r e16bdc0054ce src/goal_gui.cpp
--- a/src/goal_gui.cpp
+++ b/src/goal_gui.cpp
@@ -184,7 +184,15 @@
 
 		resize->height = d.height;
 
-		d.height *= 5;
+		uint num = 0;
+		const Goal *s;
+		FOR_ALL_GOALS(s) {
+			if (s->company == INVALID_COMPANY || s->company == this->window_number) {
+				num++;
+			}
+		}
+
+		d.height *= (5 + num);
 		d.width += padding.width + WD_FRAMERECT_RIGHT + WD_FRAMERECT_LEFT;
 		d.height += padding.height + WD_FRAMERECT_TOP + WD_FRAMERECT_BOTTOM;
 		*size = maxdim(*size, d);
diff -r e16bdc0054ce src/graph_gui.cpp
--- a/src/graph_gui.cpp
+++ b/src/graph_gui.cpp
@@ -103,6 +103,23 @@
 	}
 };
 
+
+/** Construct the row containing the digit keys. */
+static NWidgetBase *MakeCargoButtons(int *biggest_index)
+{
+	NWidgetVertical *ver = new NWidgetVertical;
+
+	for (int i = 0; i < _sorted_standard_cargo_specs_size; i++) {
+		NWidgetBackground *leaf = new NWidgetBackground(WWT_PANEL, COLOUR_ORANGE, WID_CPR_CARGO_FIRST + i, NULL);
+		leaf->tool_tip = STR_GRAPH_CARGO_PAYMENT_TOGGLE_CARGO;
+		leaf->SetFill(1, 0);
+		leaf->SetLowered(true);
+		ver->Add(leaf);
+	}
+	*biggest_index = WID_CPR_CARGO_FIRST + _sorted_standard_cargo_specs_size - 1;
+	return ver;
+}
+
 /**
  * Construct a vertical list of buttons, one for each company.
  * @param biggest_index Storage for collecting the biggest index used in the returned tree.
@@ -533,10 +550,64 @@
 		return INVALID_DATAPOINT;
 	}
 
+	void UpdateExcludedData()
+	{
+		this->excluded_data = 0;
+
+		int i = 0;
+		const CargoSpec *cs;
+		FOR_ALL_SORTED_STANDARD_CARGOSPECS(cs) {
+			if (HasBit(_legend_excluded_cargo, cs->Index())) SetBit(this->excluded_data, i);
+			i++;
+		}
+	}
+
+	void UpdateLoweredWidgets()
+	{
+		for (int i = 0; i < _sorted_standard_cargo_specs_size; i++) {
+			this->SetWidgetLoweredState(WID_CPR_CARGO_FIRST + i, !HasBit(this->excluded_data, i));
+		}
+	}
+
 	virtual void OnClick(Point pt, int widget, int click_count)
 	{
+		switch (widget) {
 		/* Clicked on legend? */
-		if (widget == WID_CV_KEY_BUTTON) ShowGraphLegend();
+			case WID_CV_KEY_BUTTON:
+				ShowGraphLegend();
+				break;
+			case WID_CPR_ENABLE_CARGOES:
+				/* Remove all cargoes from the excluded lists. */
+				_legend_excluded_cargo = 0;
+				this->excluded_data = 0;
+				this->UpdateLoweredWidgets();
+				this->SetDirty();
+				break;
+
+			case WID_CPR_DISABLE_CARGOES: {
+				/* Add all cargoes to the excluded lists. */
+				int i = 0;
+				const CargoSpec *cs;
+				FOR_ALL_SORTED_STANDARD_CARGOSPECS(cs) {
+					SetBit(_legend_excluded_cargo, cs->Index());
+					SetBit(this->excluded_data, i);
+					i++;
+				}
+				this->UpdateLoweredWidgets();
+				this->SetDirty();
+				break;
+			}
+
+			default:
+				if (widget >= WID_CPR_CARGO_FIRST) {
+					int i = widget - WID_CPR_CARGO_FIRST;
+					ToggleBit(_legend_excluded_cargo, _sorted_cargo_specs[i]->Index());
+					this->ToggleWidgetLoweredState(widget);
+					this->UpdateExcludedData();
+					this->SetDirty();
+				}
+				break;
+		}
 	}
 
 	virtual void OnTick()
@@ -674,8 +745,60 @@
 
 	virtual OverflowSafeInt64 GetGraphData(const Company *c, int j)
 	{
+		if(_legend_excluded_cargo == 0){
 		return c->old_economy[j].income;
 	}
+		uint total_income = 0;
+		const CargoSpec *cs;
+		FOR_ALL_SORTED_STANDARD_CARGOSPECS(cs) {
+			if (!HasBit(_legend_excluded_cargo, cs->Index())){
+				total_income += c->old_economy[j].cargo_income[cs->Index()];
+			}
+		}
+		return total_income;
+	}
+
+	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
+	{
+		if (widget < WID_CPR_CARGO_FIRST) {
+			BaseGraphWindow::UpdateWidgetSize(widget, size, padding, fill, resize);
+			return;
+		}
+
+		const CargoSpec *cs = _sorted_cargo_specs[widget - WID_CPR_CARGO_FIRST];
+		SetDParam(0, cs->name);
+		Dimension d = GetStringBoundingBox(STR_GRAPH_CARGO_PAYMENT_CARGO);
+		d.width += 14; // colour field
+		d.width += WD_FRAMERECT_LEFT + WD_FRAMERECT_RIGHT;
+		d.height += WD_FRAMERECT_TOP + WD_FRAMERECT_BOTTOM;
+		*size = maxdim(d, *size);
+	}
+
+	virtual void DrawWidget(const Rect &r, int widget) const
+	{
+		if (widget < WID_CPR_CARGO_FIRST) {
+			BaseGraphWindow::DrawWidget(r, widget);
+			return;
+		}
+
+		const CargoSpec *cs = _sorted_cargo_specs[widget - WID_CPR_CARGO_FIRST];
+		bool rtl = _current_text_dir == TD_RTL;
+
+		/* Since the buttons have no text, no images,
+		 * both the text and the coloured box have to be manually painted.
+		 * clk_dif will move one pixel down and one pixel to the right
+		 * when the button is clicked */
+		byte clk_dif = this->IsWidgetLowered(widget) ? 1 : 0;
+		int x = r.left + WD_FRAMERECT_LEFT;
+		int y = r.top;
+
+		int rect_x = clk_dif + (rtl ? r.right - 12 : r.left + WD_FRAMERECT_LEFT);
+
+		GfxFillRect(rect_x, y + clk_dif, rect_x + 8, y + 5 + clk_dif, PC_BLACK);
+		GfxFillRect(rect_x + 1, y + 1 + clk_dif, rect_x + 7, y + 4 + clk_dif, cs->legend_colour);
+		SetDParam(0, cs->name);
+		DrawString(rtl ? r.left : x + 14 + clk_dif, (rtl ? r.right - 14 + clk_dif : r.right), y + clk_dif, STR_GRAPH_CARGO_PAYMENT_CARGO);
+	}
 };
 
 static const NWidgetPart _nested_income_graph_widgets[] = {
@@ -690,6 +813,14 @@
 	NWidget(WWT_PANEL, COLOUR_GREY, WID_CV_BACKGROUND),
 		NWidget(NWID_HORIZONTAL),
 			NWidget(WWT_EMPTY, COLOUR_GREY, WID_CV_GRAPH), SetMinimalSize(576, 128), SetFill(1, 1), SetResize(1, 1),
+			NWidget(NWID_VERTICAL),//add
+				NWidget(NWID_SPACER), SetMinimalSize(0, 24), SetFill(0, 0), SetResize(0, 1),
+				NWidget(WWT_PUSHTXTBTN, COLOUR_ORANGE, WID_CPR_ENABLE_CARGOES), SetDataTip(STR_GRAPH_CARGO_ENABLE_ALL, STR_GRAPH_CARGO_TOOLTIP_ENABLE_ALL), SetFill(1, 0),
+				NWidget(WWT_PUSHTXTBTN, COLOUR_ORANGE, WID_CPR_DISABLE_CARGOES), SetDataTip(STR_GRAPH_CARGO_DISABLE_ALL, STR_GRAPH_CARGO_TOOLTIP_DISABLE_ALL), SetFill(1, 0),
+				NWidget(NWID_SPACER), SetMinimalSize(0, 4),
+				NWidgetFunction(MakeCargoButtons),
+				NWidget(NWID_SPACER), SetMinimalSize(0, 24), SetFill(0, 1), SetResize(0, 1),
+			EndContainer(),//add
 			NWidget(NWID_VERTICAL),
 				NWidget(NWID_SPACER), SetFill(0, 1), SetResize(0, 1),
 				NWidget(WWT_RESIZEBOX, COLOUR_GREY, WID_CV_RESIZE),
@@ -723,8 +854,60 @@
 
 	virtual OverflowSafeInt64 GetGraphData(const Company *c, int j)
 	{
+		if(_legend_excluded_cargo == 0){
 		return c->old_economy[j].delivered_cargo.GetSum<OverflowSafeInt64>();
 	}
+		uint total_delivered = 0;
+		const CargoSpec *cs;
+		FOR_ALL_SORTED_STANDARD_CARGOSPECS(cs) {
+			if (!HasBit(_legend_excluded_cargo, cs->Index())){
+				total_delivered += c->old_economy[j].delivered_cargo[cs->Index()];
+			}
+		}
+		return total_delivered;
+	}
+
+	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
+	{
+		if (widget < WID_CPR_CARGO_FIRST) {
+			BaseGraphWindow::UpdateWidgetSize(widget, size, padding, fill, resize);
+			return;
+		}
+
+		const CargoSpec *cs = _sorted_cargo_specs[widget - WID_CPR_CARGO_FIRST];
+		SetDParam(0, cs->name);
+		Dimension d = GetStringBoundingBox(STR_GRAPH_CARGO_PAYMENT_CARGO);
+		d.width += 14; // colour field
+		d.width += WD_FRAMERECT_LEFT + WD_FRAMERECT_RIGHT;
+		d.height += WD_FRAMERECT_TOP + WD_FRAMERECT_BOTTOM;
+		*size = maxdim(d, *size);
+	}
+
+	virtual void DrawWidget(const Rect &r, int widget) const
+	{
+		if (widget < WID_CPR_CARGO_FIRST) {
+			BaseGraphWindow::DrawWidget(r, widget);
+			return;
+		}
+
+		const CargoSpec *cs = _sorted_cargo_specs[widget - WID_CPR_CARGO_FIRST];
+		bool rtl = _current_text_dir == TD_RTL;
+
+		/* Since the buttons have no text, no images,
+		 * both the text and the coloured box have to be manually painted.
+		 * clk_dif will move one pixel down and one pixel to the right
+		 * when the button is clicked */
+		byte clk_dif = this->IsWidgetLowered(widget) ? 1 : 0;
+		int x = r.left + WD_FRAMERECT_LEFT;
+		int y = r.top;
+
+		int rect_x = clk_dif + (rtl ? r.right - 12 : r.left + WD_FRAMERECT_LEFT);
+
+		GfxFillRect(rect_x, y + clk_dif, rect_x + 8, y + 5 + clk_dif, PC_BLACK);
+		GfxFillRect(rect_x + 1, y + 1 + clk_dif, rect_x + 7, y + 4 + clk_dif, cs->legend_colour);
+		SetDParam(0, cs->name);
+		DrawString(rtl ? r.left : x + 14 + clk_dif, (rtl ? r.right - 14 + clk_dif : r.right), y + clk_dif, STR_GRAPH_CARGO_PAYMENT_CARGO);
+	}
 };
 
 static const NWidgetPart _nested_delivered_cargo_graph_widgets[] = {
@@ -739,6 +922,15 @@
 	NWidget(WWT_PANEL, COLOUR_GREY, WID_CV_BACKGROUND),
 		NWidget(NWID_HORIZONTAL),
 			NWidget(WWT_EMPTY, COLOUR_GREY, WID_CV_GRAPH), SetMinimalSize(576, 128), SetFill(1, 1), SetResize(1, 1),
+			NWidget(NWID_VERTICAL),//add
+				NWidget(NWID_SPACER), SetMinimalSize(0, 24), SetFill(0, 0), SetResize(0, 1),
+				NWidget(WWT_PUSHTXTBTN, COLOUR_ORANGE, WID_CPR_ENABLE_CARGOES), SetDataTip(STR_GRAPH_CARGO_ENABLE_ALL, STR_GRAPH_CARGO_TOOLTIP_ENABLE_ALL), SetFill(1, 0),
+				NWidget(WWT_PUSHTXTBTN, COLOUR_ORANGE, WID_CPR_DISABLE_CARGOES), SetDataTip(STR_GRAPH_CARGO_DISABLE_ALL, STR_GRAPH_CARGO_TOOLTIP_DISABLE_ALL), SetFill(1, 0),
+				NWidget(NWID_SPACER), SetMinimalSize(0, 4),
+				NWidgetFunction(MakeCargoButtons),
+				NWidget(NWID_SPACER), SetMinimalSize(0, 24), SetFill(0, 1), SetResize(0, 1),
+			EndContainer(),//add
+			NWidget(NWID_SPACER), SetMinimalSize(5, 0), SetFill(0, 1), SetResize(0, 1),
 			NWidget(NWID_VERTICAL),
 				NWidget(NWID_SPACER), SetFill(0, 1), SetResize(0, 1),
 				NWidget(WWT_RESIZEBOX, COLOUR_GREY, WID_CV_RESIZE),
@@ -899,7 +1091,7 @@
 		}
 		this->first_init = false;
 	}
-
+/*
 	void UpdateExcludedData()
 	{
 		this->excluded_data = 0;
@@ -918,7 +1110,7 @@
 			this->SetWidgetLoweredState(WID_CPR_CARGO_FIRST + i, !HasBit(this->excluded_data, i));
 		}
 	}
-
+*/
 	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
 	{
 		if (widget < WID_CPR_CARGO_FIRST) {
@@ -960,12 +1152,12 @@
 		SetDParam(0, cs->name);
 		DrawString(rtl ? r.left : x + 14 + clk_dif, (rtl ? r.right - 14 + clk_dif : r.right), y + clk_dif, STR_GRAPH_CARGO_PAYMENT_CARGO);
 	}
-
+/*
 	virtual void OnClick(Point pt, int widget, int click_count)
 	{
 		switch (widget) {
 			case WID_CPR_ENABLE_CARGOES:
-				/* Remove all cargoes from the excluded lists. */
+				/* Remove all cargoes from the excluded lists. * /
 				_legend_excluded_cargo = 0;
 				this->excluded_data = 0;
 				this->UpdateLoweredWidgets();
@@ -973,7 +1165,7 @@
 				break;
 
 			case WID_CPR_DISABLE_CARGOES: {
-				/* Add all cargoes to the excluded lists. */
+				/* Add all cargoes to the excluded lists. * /
 				int i = 0;
 				const CargoSpec *cs;
 				FOR_ALL_SORTED_STANDARD_CARGOSPECS(cs) {
@@ -997,7 +1189,7 @@
 				break;
 		}
 	}
-
+*/
 	virtual void OnTick()
 	{
 		/* Override default OnTick */
@@ -1031,23 +1223,6 @@
 	}
 };
 
-/** Construct the row containing the digit keys. */
-static NWidgetBase *MakeCargoButtons(int *biggest_index)
-{
-	NWidgetVertical *ver = new NWidgetVertical;
-
-	for (int i = 0; i < _sorted_standard_cargo_specs_size; i++) {
-		NWidgetBackground *leaf = new NWidgetBackground(WWT_PANEL, COLOUR_ORANGE, WID_CPR_CARGO_FIRST + i, NULL);
-		leaf->tool_tip = STR_GRAPH_CARGO_PAYMENT_TOGGLE_CARGO;
-		leaf->SetFill(1, 0);
-		leaf->SetLowered(true);
-		ver->Add(leaf);
-	}
-	*biggest_index = WID_CPR_CARGO_FIRST + _sorted_standard_cargo_specs_size - 1;
-	return ver;
-}
-
-
 static const NWidgetPart _nested_cargo_payment_rates_widgets[] = {
 	NWidget(NWID_HORIZONTAL),
 		NWidget(WWT_CLOSEBOX, COLOUR_GREY),
diff -r e16bdc0054ce src/gui.h
--- a/src/gui.h
+++ b/src/gui.h
@@ -39,12 +39,16 @@
 /* airport_gui.cpp */
 Window *ShowBuildAirToolbar();
 
+/* commands_gui.cpp */
+void ShowCommandsToolbar();
+void ShowLoginWindow();
+
 /* tgp_gui.cpp */
 void ShowGenerateLandscape();
 void ShowHeightmapLoad();
 
 /* misc_gui.cpp */
-void ShowLandInfo(TileIndex tile);
+void ShowLandInfo(TileIndex tile, TileIndex end_tile=INVALID_TILE);
 void ShowAboutWindow();
 void ShowBuildTreesToolbar();
 void ShowTownDirectory();
diff -r e16bdc0054ce src/hotkeys.cpp
--- a/src/hotkeys.cpp
+++ b/src/hotkeys.cpp
@@ -61,6 +61,22 @@
 	{"NUM_MINUS", WKC_NUM_MINUS},
 	{"=", WKC_EQUALS},
 	{"-", WKC_MINUS},
+
+	{"BACKSPACE", WKC_BACKSPACE},
+	{"SLASH", WKC_SLASH},
+	{"SEMICOLON", WKC_SEMICOLON},
+	{"L_BRACKET", WKC_L_BRACKET},
+	{"BACKSLASH", WKC_BACKSLASH},
+	{"R_BRACKET", WKC_R_BRACKET},
+	{"SINGLEQUOTE", WKC_SINGLEQUOTE},
+	{"PERIOD", WKC_PERIOD},
+
+	{"L_BRACE", WKC_L_BRACE},
+	{"R_BRACE", WKC_R_BRACE},
+	{"L_PAREN", WKC_L_PAREN},
+	{"R_PAREN", WKC_R_PAREN},
+	{"EXCLAIM", WKC_EXCLAIM},
+	{"ASTERISK", WKC_ASTERISK},
 };
 
 /**
diff -r e16bdc0054ce src/industry_cmd.cpp
--- a/src/industry_cmd.cpp
+++ b/src/industry_cmd.cpp
@@ -1844,6 +1844,40 @@
 }
 
 /**
+  * Return whether industry can be built on tile or not
+  * regardless of terrain
+  */
+bool CanBuildIndustryOnTile(IndustryType type, TileIndex tile) {
+	const IndustrySpec *indspec = GetIndustrySpec(type);
+    CommandCost ret;
+
+	if (HasBit(indspec->callback_mask, CBM_IND_LOCATION)) {
+		ret = CheckIfCallBackAllowsCreation(
+			tile, type, 0, 0, 0, _current_company,
+			_current_company == OWNER_DEITY ? IACT_RANDOMCREATION : IACT_USERCREATION);
+	} else {
+		ret = _check_new_industry_procs[GetIndustrySpec(type)->check_proc](tile);
+	}
+	if (ret.Failed())
+		return false;
+
+	ret = CheckIfFarEnoughFromConflictingIndustry(tile, type);
+	if (ret.Failed())
+		return false;
+
+	Town *t = NULL;
+	ret = FindTownForIndustry(tile, type, &t);
+	if (ret.Failed())
+		return false;
+
+	ret = CheckIfIndustryIsAllowed(tile, type, t);
+	if (ret.Failed())
+		return false;
+
+	return true;
+}
+
+/**
  * Build/Fund an industry
  * @param tile tile where industry is built
  * @param flags of operations to conduct
